Knight Moves
Time Limit: 1000MS   Memory Limit: 30000K
Total Submissions: 26952   Accepted: 12721

Description

Background 
Mr Somurolov, fabulous chess-gamer indeed, asserts that no one else but him can move knights from one position to another so fast. Can you beat him? 
The Problem 
Your task is to write a program to calculate the minimum number of moves needed for a knight to reach one point from another, so that you have the chance to be faster than Somurolov. 
For people not familiar with chess, the possible knight moves are shown in Figure 1. 

Input

The input begins with the number n of scenarios on a single line by itself. 
Next follow n scenarios. Each scenario consists of three lines containing integer numbers. The first line specifies the length l of a side of the chess board (4 <= l <= 300). The entire board has size l * l. The second and third line contain pair of integers {0, ..., l-1}*{0, ..., l-1} specifying the starting and ending position of the knight on the board. The integers are separated by a single blank. You can assume that the positions are valid positions on the chess board of that scenario.

Output

For each scenario of the input you have to calculate the minimal amount of knight moves which are necessary to move from the starting point to the ending point. If starting point and ending point are equal,distance is zero. The distance must be written on a single line.

Sample Input

3
8
0 0
7 0
100
0 0
30 50
10
1 1
1 1

Sample Output

5
28
0

Source

TUD Programming Contest 2001, Darmstadt, Germany
 
题目大意: 求马从一个点到另一个点需要的最少步数。
解题思路:经典的bfs求最短路径,利用优先队列(每次都是当前步数小的先出队),直接根据题目给的走路方法(dx[8]={-2,-2,-1,-1,1,1,2,2}; dy[8]={1,-1,2,-2,2,-2,1,-1};)进行bfs即可。(由于多组数据,每次bfs都要清空数据,也就是使队列为空)
 
#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;

const int MAX=305;
int l,sx,sy,ex,ey;
int dx[8]={-2,-2,-1,-1,1,1,2,2};
int dy[8]={1,-1,2,-2,2,-2,1,-1};
bool vis[MAX][MAX];
struct Node
{
    int x,y,step;
    bool operator < (const Node &a) const{
        return a.step<step;
    }
};
priority_queue<Node> q;//利用优先队列,每次出队的为步数较小的。

void bfs()
{
    Node now,next;
    now.x=sx; now.y=sy; now.step=0;
    while(!q.empty())    //由于多组数据,每次bfs都要清空q
    {
        q.pop();
    }
    q.push(now);
    while(!q.empty())
    {
        now = q.top();
        q.pop();
        if(now.x==ex&&now.y==ey) //bfs结束,找到出口
        {
            printf("%dn",now.step);
            break;
        }
        for(int i=0;i<8;i++)
        {
            next.x = now.x+dx[i];
            next.y = now.y+dy[i];
            if(next.x>=0&&next.x<l &&next.y>=0&&next.y<l && !vis[next.x][next.y])
            {
                vis[next.x][next.y]=true;
                next.step = now.step+1;
                q.push(next);
            }
        }
    }
}

int main()
{
    int Case;
    scanf("%d",&Case);
    while(Case--)
    {
        memset(vis,false,sizeof(vis));
        scanf("%d",&l);
        scanf("%d %d",&sx,&sy);
        scanf("%d %d",&ex,&ey);
        bfs();
        //printf("bfs-endn");
    }
}

 

内容来源于网络如有侵权请私信删除
你还没有登录,请先登录注册
  • 还没有人评论,欢迎说说您的想法!